      /* Graphics demo for ega1512.lib v1.5 NOVELLA 1990  */

 #include<stdlib.h>
 #include<conio.h>
 #include<dos.h>
 #include<graphics.h>
 #include<ega1512.h>

 #define ESC   0x1b
 #define MaxX  639
 #define MaxY1 180
 #define MaxY2 199

 void Initialise(void);
 void Textdemo(void);
 void Drawingdemo(void);
 void Fillingdemo(void);
 void Imagedemo(void);
 void Pause(void);
 void Title_box(char *Title);
 void flush_keyboard_buffer(void);

main()
  {
 if(registerbgidriver(CGA_driver) <0) exit(1);
 if(registerbgifont(triplex_font) <0) exit(1);
 Initialise();
 Textdemo();
 Drawingdemo();
 Fillingdemo();
 Imagedemo();
 closegraph();
  }

void Initialise(void)
  {
  ega1512_setmode("");      /* select 16 colour Hi-res mode */
  }

void Textdemo(void)
  {
  char *msg1 = "WELCOME";
  int y;
  settextjustify(LEFT_TEXT,CENTER_TEXT);
  setusercharsize(2,1,1,1);
  settextstyle(TRIPLEX_FONT,HORIZ_DIR,USER_CHAR_SIZE);
  setusercharsize(400,textwidth(msg1),50,textheight(msg1));
    for(y=0;y<160;y+=10)
      ega1512_outtextxy(100+y,y+10,msg1,y/10);
  setfillstyle(SOLID_FILL,1);
  ega1512_fastbar(64,81,519,119,BLACK);
  ega1512_rectangle(63,80,520,120,4);
  settextjustify(CENTER_TEXT,CENTER_TEXT);
  settextstyle(DEFAULT_FONT,HORIZ_DIR,2);
  ega1512_outtextxy(300,100,"To The 16 Colour PC1512",15);

  Pause();
  }

void Drawingdemo(void)
  {
  int colour,box_size = 4,y = 0,px,py;
  int A_shape[] = {330,32, 381,60, 480,60, 426,90, 480,120, 381,120, 330,148,
		   279,120, 180,120, 228,90, 180,60, 279,60, 330,32};

  struct arccoordstype point;


  Title_box("ega1512_arc ......     Press any key to stop");

  while(!kbhit())
    {
    colour = random(15)+1;

    ega1512_arc(random(MaxX),random(MaxY1),random(180),random(180)+180,
                random(50)+10,colour);

    getarccoords( &point);

    ega1512_line(point.x, point.y, point.xstart, point.ystart, colour);
    ega1512_line(point.x, point.y, point.xend, point.yend, colour);
    }
  Pause();


  Title_box("ega1512_circle ...     Press any key to stop");

  while(!kbhit())
    {
    ega1512_circle(random(MaxX),random(MaxY1),random(50)+10,random(15)+1);
    }
  Pause();


  Title_box("ega1512_ellipse ...     Press any key to stop");

  while(!kbhit())
    {
    ega1512_ellipse(random(MaxX),random(MaxY1),0,360,random(40)+4,
		    random(20)+4,random(15)+1);
    }
  Pause();


  Title_box("ega1512_rectangle .......     Press any key to stop");

  setlinestyle(SOLID_LINE,0,THICK_WIDTH);

  while(!kbhit())
    {
      ega1512_rectangle(box_size*2,box_size/2,MaxX-(box_size*2),
			MaxY1-(box_size/2),random(15)+1);
      box_size+=8;
      if(box_size>150) box_size=4;
    }
  Pause();


  Title_box("ega1512_line ...........      Press any key to stop");

  while(!kbhit())
    {
    setlinestyle(random(3),0,NORM_WIDTH);
    ega1512_line(0,y,MaxX,y,random(15)+1);
    y+=4;
    setlinestyle(4,random(0xffff),NORM_WIDTH);
    ega1512_line(0,y,MaxX,y,random(15)+1);
    y+=4;
    if(y>MaxY1) { y=0; ega1512_clearviewport(); }
    }

  Pause();


  Title_box("ega1512_linerel .........      Press any key to stop");

  setlinestyle(SOLID_LINE,0,NORM_WIDTH);
  while(!kbhit())
    {
    moveto(200,65);
    colour = random(15)+1;
    ega1512_linerel(+200,0,colour);
    ega1512_linerel(+100,-50,colour);
    ega1512_linerel(-200,0,colour);
    ega1512_linerel(-100,+50,colour);
    ega1512_linerel(0,+100,colour);
    ega1512_linerel(+200,0,colour);
    ega1512_linerel(0,-100,colour);
    ega1512_linerel(0,+100,colour);
    ega1512_linerel(+100,-50,colour);
    ega1512_linerel(0,-100,colour);
    delay(500);
    }

  Pause();


  Title_box("ega1512_lineto ..........      Press any key to stop");

  while(!kbhit())
    {
      moveto(random(MaxX),random(MaxY1));
      ega1512_lineto(300,90,random(15)+1);
    }

  Pause();


  Title_box("ega1512_drawpoly ........      Press any key to stop");

  while(!kbhit())
    {
    colour = random(15)+1;
    ega1512_drawpoly(sizeof(A_shape)/(2*sizeof(int)),A_shape,colour);
    delay(500);
    }

  Pause();


  Title_box("ega1512_putpixel ........");

    for(y=0;y<2000;y++)
      {
      px = random(MaxX);
      py = random(MaxY1);
	ega1512_putpixel(px,py,random(15)+1);
        colour = ega1512_getpixel(px,py);
          if(colour == 4) ega1512_outtextxy(px,py,"*",2);  /* If RED pixel */
      }                                                    /* print "*"    */
  Pause();
  }


void Fillingdemo(void)
  {
  int l,t,x,y,colour;
  int shape1[] = { 200,80, 400,80, 400,160, 200,160, 200,80 };
  int shape2[] = { 200,80, 300,20, 500,20, 400,80, 200,80 };
  int shape3[] = { 400,80, 500,20, 500,100, 400,160, 400,80 };
  char blend[] = { 0xAA,0x55,0xAA,0x55,0xAA,0x55,0xAA,0x55};
  int shape4[] = { 0,0, 0,0, 0,0 };


  Title_box("ega1512_bar .............");

  setfillstyle(SOLID_FILL,1);
  ega1512_fastbar(0,0,MaxX,MaxY1,DARKGRAY);

    ega1512_line(10,170,600,170,WHITE);
    ega1512_line(10,0,10,170,WHITE);

      for(x=0;x<16;x++)
        {
        setfillstyle(random(11)+1,1);
        ega1512_bar(x*39,x*9,(x*39)+39,169,x);
        }

  Pause();


  Title_box("ega1512_bar3d ...........");

  setfillstyle(SOLID_FILL,1);
  ega1512_fastbar(0,0,MaxX,MaxY1,LIGHTBLUE);

    ega1512_line(10,170,600,170,RED);
    ega1512_line(10,0,10,170,RED);

      for(x=0;x<16;x++)
	{
	setfillstyle(random(11)+1,1);
	ega1512_bar3d(x*39,140-(x*8),(x*39)+39,169,10,1,x,15-x);
	}

  Pause();


  Title_box("ega1512_pieslice ........");

  setfillstyle(SOLID_FILL,1);                         /* N.B. This is no way */
  ega1512_pieslice(300,100,0,20,120,RED,WHITE);       /* to calculate a pie  */
    setfillstyle(SOLID_FILL,1);                       /* chart - demo of     */
    ega1512_pieslice(300,100,20,100,120,GREEN,WHITE); /* graphics functions  */
      setfillstyle(CLOSE_DOT_FILL,1);                 /* only.               */
      ega1512_pieslice(220,84,100,220,120,YELLOW,RED);
        setfillstyle(SOLID_FILL,1);
	ega1512_pieslice(300,100,220,360,120,BLUE,WHITE);

      ega1512_textcolor(WHITE);
      outtextxy(440,95,"1985");
      outtextxy(400,60,"1986");
      ega1512_textcolor(MAGENTA);
      outtextxy(92,60,"1987");
      ega1512_textcolor(WHITE);
       outtextxy(320,165,"1988");

    settextjustify(CENTER_TEXT,CENTER_TEXT);
    settextstyle(TRIPLEX_FONT,HORIZ_DIR,4);
    ega1512_outtextxy(300,20,"Sales",BLUE);

  Pause();


  Title_box("ega1512_fillpoly ........      Press any key to stop");

  while(!kbhit())
    {
       colour = random(15)+1;
       setfillstyle(SOLID_FILL,1);                   /* If you have trouble */
       ega1512_fillpoly(5,shape1,random(15),0);      /* with outline color  */
       ega1512_drawpoly(5,shape1,colour);            /* then draw the shape */
	 ega1512_fillpoly(5,shape2,random(15),0);    /* without a border    */
	 ega1512_drawpoly(5,shape2,colour);          /* then use drawpoly   */
	   ega1512_fillpoly(5,shape3,random(15),0);  /* to give an outline  */
           ega1512_drawpoly(5,shape3,colour);        /* of desired color    */
     delay(1000);
     }

  Pause();


  Title_box("user_ega1512_bar .......      Press any key to stop");

  l = t = 0;
  while(!kbhit())
    {
      setfillstyle(SOLID_FILL,1);
      ega1512_bar(l,t,l+16,t+8,random(16));
	 setfillpattern(blend,1);
	 user_ega1512_bar(l,t,l+16,t+8,random(16));

      l+=16;
      if(l== 624)
	{
	l = 0;
	t+= 16;
	  if(t == 192) t = 0;
	}
    }

  Pause();

  Title_box("user_ega1512_fillpoly ....... Press any key to stop");

  while(!kbhit())
    {
    shape4[0] = random(MaxX);
    shape4[1] = random(MaxY1);
    shape4[2] = random(MaxX);
    shape4[3] = random(MaxY1);
    shape4[4] = random(MaxX);
    shape4[5] = random(MaxY1);

    setfillstyle(SOLID_FILL,1);
    ega1512_fillpoly(3,shape4,random(16),0);
      setfillpattern(blend,1);
      user_ega1512_fillpoly(3,shape4,random(16),0);
    }
 Pause();

 Title_box("user_ega1512_pieslice .......");

   setfillstyle(SOLID_FILL,1);
   ega1512_pieslice(320,90,0,60,100,0,4);
   ega1512_pieslice(320,90,60,120,100,12,4);
   ega1512_pieslice(320,90,120,180,100,12,4);
   ega1512_pieslice(320,90,180,240,100,5,4);
   ega1512_pieslice(320,90,240,300,100,15,4);
   ega1512_pieslice(320,90,300,360,100,15,4);

   setfillpattern(blend,1);
   user_ega1512_pieslice(320,90,0,60,100,4,4);
   user_ega1512_pieslice(320,90,60,120,100,12,4);
   user_ega1512_pieslice(320,90,120,180,100,4,4);
   user_ega1512_pieslice(320,90,180,240,100,3,4);
   user_ega1512_pieslice(320,90,240,300,100,11,4);
   user_ega1512_pieslice(320,90,300,360,100,3,4);

  Pause();

 }


void Imagedemo(void)
  {
  char far *Picture;
  char far *Cross;
  int x,y;
  unsigned int size1,size2;

   setfillstyle(11,1);
   ega1512_fastbar(0,0,100,100,YELLOW);
     for(x=0;x<16;x++)
       ega1512_rectangle(x*2,x*2,100-(x*2),100-(x*2),x);

   size1 = imagesize(0,0,100,100);
   Picture = (char *)malloc(size1 * 4); /* (size1 * 4) because we have to  */
                                               /* store four colour planes */
   ega1512_getimage(0,0,100,100,Picture,size1); /* ie. four images to make */
                                                /* one 16 colour image     */
      ega1512_cleardevice();

  ega1512_line(0,4,10,4,WHITE);
  ega1512_line(5,0,5,8,WHITE);

  size2 = imagesize(0,0,10,8);
  Cross = (char *)malloc(size2 * 4);         /* same as above - 4 planes */

  ega1512_getimage(0,0,10,8,Cross,size2);

    ega1512_cleardevice();

  Title_box("ega1512_putimage / getimage ....");

  for(x=0;x<540;x+=100)
    ega1512_putimage(x,50,Picture,size1,COPY_PUT);

    for(x=20;x<600;x++)
      {
      y=x/4;
        ega1512_putimage(x,y,Cross,size2,XOR_PUT);
        ega1512_putimage(x,y,Cross,size2,XOR_PUT);
      }

  setviewport(100,90,500,110,1);
  ega1512_clearviewport();
   ega1512_rectangle(4,2,396,18,RED);
   ega1512_outtextxy(200,14,"Bye for now",15);

  Pause();
  }


void Title_box(char *Title)
  {
  ega1512_outtextxy(300,190,Title,15);
  setviewport(0,0,MaxX,MaxY1,1);
  }


void Pause(void)
  {
  setviewport(0,0,639,199,1);

  settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
  settextjustify(CENTER_TEXT,HORIZ_DIR);

  setlinestyle(SOLID_LINE,0,NORM_WIDTH);
  setfillstyle(SOLID_FILL,1);

  ega1512_fastbar(0,180,639,199,BLACK);

  ega1512_textcolor(9);
  outtextxy(300,190,"Press any key to continue or Esc to quit");

  flush_keyboard_buffer();
  if(getch() == ESC )
    {
    closegraph();
    exit(1);
    }
  ega1512_scrborder(random(15+1));         /* set screen border to any color */
  ega1512_cleardevice();
  }

void flush_keyboard_buffer(void)
  {
  union REGS in,out;
  in.x.ax = 0x0c00;
  intdos(&in,&out);
  }
