 /*                         v1.4  NOVELLA 1989                              */
 /*                                                                         */
 /*     EXAMPLE 1   One way to save a 16 colour screen image to disk and    */
 /*                 get it back again.                                      */
 /*                                                                         */
 /*         Note:   farmalloc is used to allocate memory for the screen     */
 /*                 image, this is to enable a full screen image of 64K     */
 /*                 to be stored even when using the small memory model.    */


 #include<graphics.h>
 #include<ega1512.h>
 #include<alloc.h>
 #include<stdio.h>
 #include<stdlib.h>
 #include<string.h>

 #define PICLEFT   300                 /*  Value for full screen image 0    */
 #define PICTOP    100                 /*  Value for full screen image 0    */
 #define PICRIGHT  600                 /*  Value for full screen image 639  */
 #define PICBOTTOM 199                 /*  Value for full screen image 199  */

 void paint(void);
 void save_pic(void);
 void show_pic(void);
 void interlude(void);

main()
  {
  ega1512_setmode("");
  paint();
  save_pic();
  interlude();
  show_pic();
  exit(0);
  }

void paint(void)                             /* Draw a multicoloured image  */
  {
   int x;

     for(x=PICLEFT;x<PICRIGHT;x+=4)
       {
       setfillstyle(SOLID_FILL,1);
       ega1512_bar(x,PICTOP,x+4,PICBOTTOM,random(14)+1);
       }
  }

void save_pic(void)
  {
  char far *picture;
  int size1;                        /* size1 can be an integer because max  */
  unsigned int pic_byte;            /* size of screen = 80 x 200 bytes      */
  FILE *fp;                         /* and 16000 fits into an integer.      */
                                    /* pic_byte however has to deal with 4  */
				    /* sets of 16000 and 16000 x 4 = 64000  */
				    /* which clearly must be unsigned int   */


  size1 = imagesize(PICLEFT,PICTOP,PICRIGHT,PICBOTTOM);
  picture =farmalloc((unsigned long)size1 * 4 );

    if(picture == NULL)
      {
      ega1512_outtextxy(1,10,"Failed to allocate",15);
      exit(1);
      }

  ega1512_getimage(PICLEFT,PICTOP,PICRIGHT,PICBOTTOM,picture,(unsigned)size1);

  fp = fopen("test.pic","w");
  putw(size1,fp);

    for(pic_byte=0;pic_byte<(size1 * 4);pic_byte++)
      fputc(picture [ pic_byte ],fp);

  fclose(fp);
  farfree(picture);
  }

void show_pic(void)
  {
  char far *picback;
  int get_size;                         /* int - same reason as size1 above */
  unsigned int pic_byte;
  FILE *fp;

  fp = fopen("test.pic","r");
  get_size = getw(fp);

  picback = farmalloc((unsigned long)get_size * 4 );

    if(picback == NULL)
      {
      ega1512_outtextxy(1,10,"Failed to allocate",15);
      exit(1);
      }

    for(pic_byte=0;pic_byte<(get_size * 4);pic_byte++)
     picback[pic_byte] = fgetc(fp);

  fclose(fp);

  ega1512_putimage(0,0,picback,(unsigned)get_size,COPY_PUT);

  }

void interlude(void)
  {
   int x;
   char far *countdown;

   countdown = strtok("10,9,8,7,6,5,4,3,2,1,0",",");

   ega1512_outtextxy(10,10,"Picture saved ...",15);

   ega1512_outtextxy(10,50,"I",4);
   ega1512_outtextxy(30,50,"N",12);
   ega1512_outtextxy(50,50,"T",14);
   ega1512_outtextxy(70,50,"E",2);
   ega1512_outtextxy(90,50,"R",10);
   ega1512_outtextxy(110,50,"L",1);
   ega1512_outtextxy(130,50,"U",9);
   ega1512_outtextxy(150,50,"D",5);
   ega1512_outtextxy(170,50,"E",13);

   for(x=0;x<10;x++)
     {
     ega1512_outtextxy(90,80,countdown,15);

     countdown = strtok(NULL,",");

           delay(1000);                       /* The suspense is killing me */

     setfillstyle(SOLID_FILL,1);
     ega1512_fastbar(90,80,110,90,BLACK);
     }

   ega1512_fastbar(0,0,200,60,BLACK);
   ega1512_outtextxy(10,10,"Reloading Picture ...",15);

  }
